import Valmet.AITypes.*;

/**
 * Java source code template for class unbalLoadOpt.
 *
 */
public class unbalLoadOpt 
{

	Ana	demand;
	Bin	dg1_bin;
	Ints	dg1_pri;
	Ana	dg1_hl;
	Ana	dg1_ll;
	Ana	dg1_np;
	Bin	dg2_bin;
	Ints	dg2_pri;
	Ana	dg2_hl;
	Ana	dg2_ll;
	Ana	dg2_np;
	Bin	dg3_bin;
	Ints	dg3_pri;
	Ana	dg3_hl;
	Ana	dg3_ll;
	Ana	dg3_np;
	Bin	dg4_bin;
	Ints	dg4_pri;
	Ana	dg4_hl;
	Ana	dg4_ll;
	Ana	dg4_np;
	bin	new_data;
	AnaVector	dg1_p;
	AnaVector	dg2_p;
	AnaVector	dg3_p;
	AnaVector	dg4_p;
	Ana	dg1_sp;
	Ana	dg2_sp;
	Ana	dg3_sp;
	Ana	dg4_sp;

 /**
  * Constructor
  * Creates parameter objects and connects them 
  * to the inputs and outputs of the prog2 function block.
  *
  */
 public unbalLoadOpt() throws AITableReferenceException {

     // Connect member variables to the prog2 inputs/outputs.
   try 
   {

	demand =  new Ana("demand");
	dg1_bin =  new Bin("dg1_bin");
	dg1_pri =  new Ints("dg1_pri");
	dg1_hl =  new Ana("dg1_hl");
	dg1_ll =  new Ana("dg1_ll");
	dg1_np =  new Ana("dg1_np");
	dg2_bin =  new Bin("dg2_bin");
	dg2_pri =  new Ints("dg2_pri");
	dg2_hl =  new Ana("dg2_hl");
	dg2_ll =  new Ana("dg2_ll");
	dg2_np =  new Ana("dg2_np");
	dg3_bin =  new Bin("dg3_bin");
	dg3_pri =  new Ints("dg3_pri");
	dg3_hl =  new Ana("dg3_hl");
	dg3_ll =  new Ana("dg3_ll");
	dg3_np =  new Ana("dg3_np");
	dg4_bin =  new Bin("dg4_bin");
	dg4_pri =  new Ints("dg4_pri");
	dg4_hl =  new Ana("dg4_hl");
	dg4_ll =  new Ana("dg4_ll");
	dg4_np =  new Ana("dg4_np");
	new_data =  new bin("new_data");
	dg1_p =  new AnaVector("dg1_p");
	dg2_p =  new AnaVector("dg2_p");
	dg3_p =  new AnaVector("dg3_p");
	dg4_p =  new AnaVector("dg4_p");
	dg1_sp =  new Ana("dg1_sp");
	dg2_sp =  new Ana("dg2_sp");
	dg3_sp =  new Ana("dg3_sp");
	dg4_sp =  new Ana("dg4_sp");

   }
   catch (Throwable e)
   {
        throw new AINullTablePointerException("unbalLoadOpt: initialization failed: "
				+ e.getMessage());
   }

  
  // Check that table connections are ok.
  checkInitialTableConnections();
 }

 /**
  * checkInitialTableConnections
  * Checks that parameter tables are properly connected.
  */
 private final void checkInitialTableConnections() throws AITableReferenceException
 { 

 	try {
	  dg1_p.checkGenConnected();
	}
	catch (AITableReferenceException e) {
	throw new AITableGenCheckException("unbalLoadOpt/dg1_p: " + e.getMessage());
}
	try {
	  dg2_p.checkGenConnected();
	}
	catch (AITableReferenceException e) {
	throw new AITableGenCheckException("unbalLoadOpt/dg2_p: " + e.getMessage());
}
	try {
	  dg3_p.checkGenConnected();
	}
	catch (AITableReferenceException e) {
	throw new AITableGenCheckException("unbalLoadOpt/dg3_p: " + e.getMessage());
}
	try {
	  dg4_p.checkGenConnected();
	}
	catch (AITableReferenceException e) {
	throw new AITableGenCheckException("unbalLoadOpt/dg4_p: " + e.getMessage());
}

  
 }

 /**
  * checkTableConnections
  * Checks the integrity of the parameter tables.
  */ 
 private final void checkTableConnections() throws AITableReferenceException
 { 
	try {
	 dg1_p.checkTableFrame();
	 dg1_p.checkInputTable();
	}
	catch (AITableReferenceException e) {
	 throw new AITableGenCheckException("unbalLoadOpt/dg1_p:" + e.getMessage());
	}
	try {
	 dg2_p.checkTableFrame();
	 dg2_p.checkInputTable();
	}
	catch (AITableReferenceException e) {
	 throw new AITableGenCheckException("unbalLoadOpt/dg2_p:" + e.getMessage());
	}
	try {
	 dg3_p.checkTableFrame();
	 dg3_p.checkInputTable();
	}
	catch (AITableReferenceException e) {
	 throw new AITableGenCheckException("unbalLoadOpt/dg3_p:" + e.getMessage());
	}
	try {
	 dg4_p.checkTableFrame();
	 dg4_p.checkInputTable();
	}
	catch (AITableReferenceException e) {
	 throw new AITableGenCheckException("unbalLoadOpt/dg4_p:" + e.getMessage());
	}

 }
 
 /**
  * init
  * This method is called once for each prog2 function block
  * using this class. The method is called when the function
  * block is loaded to the application server.
  */
    public void init() {

        // Put initialization code here.
    } // End of init

    /**
     * run 
     * This method is called when the prog2 function block is executed.
     */
     public void run() {

  try {
   checkTableConnections();
   runMe();
  }
  catch (Throwable e) {
      System.err.println("unbalLoadOpt: " + e.getMessage());
  }
 
    } // End of run

    /**
     * runMe 
     * This method is called from method run().
     */     
    private void runMe()
    {
         // Put program logic code here.
    } // End of runMe

    /**
     * moduleupdate 
     * This method is called once for each prog2 function block
     * in the module that has been updated using Download to/Update method.
     */
    public void moduleupdate () {

        // Put update code here.
     
    } // End of moduleupdate
    
    /**
     * exit 
     * This method is called once for each prog2 function block
     * using this class. The method is called when the function
     * block is unloaded from the application server.
     */
    public void exit() {

        // Put clean-up code here.
	demand = null;
	dg1_bin = null;
	dg1_pri = null;
	dg1_hl = null;
	dg1_ll = null;
	dg1_np = null;
	dg2_bin = null;
	dg2_pri = null;
	dg2_hl = null;
	dg2_ll = null;
	dg2_np = null;
	dg3_bin = null;
	dg3_pri = null;
	dg3_hl = null;
	dg3_ll = null;
	dg3_np = null;
	dg4_bin = null;
	dg4_pri = null;
	dg4_hl = null;
	dg4_ll = null;
	dg4_np = null;
	new_data = null;
	dg1_p = null;
	dg2_p = null;
	dg3_p = null;
	dg4_p = null;
	dg1_sp = null;
	dg2_sp = null;
	dg3_sp = null;
	dg4_sp = null;


	System.gc();   // Propose garbage collection.

    } // End of exit
    
} // End of unbalLoadOpt
